local Utopia = LibStub("AceAddon-3.0"):GetAddon("Utopia", true)
if (not Utopia) then
	return
end
Utopia:UpdateVersion("$Revision: 213 $")

local wowVersion = tonumber((select(2,GetBuildInfo())))

local L = LibStub("AceLocale-3.0"):GetLocale("Utopia")

-- All talent scans are done by name. No messing around with slot indexes etc.
-- Notable fields:
--		interested	- The types of player interested in seeing this icon (for the automatic icon selection)

-- 4.0 TODO
-- 1) lvl calcs. All amounts are fixed to level 80 atm

Utopia.bloodlustID = UnitFactionGroup("player") == "Horde" and 2825 or 32182		-- Bloodlust/Heroism
Utopia.bloodlustList = {
	[Utopia.bloodlustID] = true,
	[80353] = true,
	[90355] = true,
}
Utopia.bloodlustNames = {}
for id in pairs(Utopia.bloodlustList) do
	Utopia.bloodlustNames[GetSpellInfo(id)] = id
end

-- Update for major patches:
Utopia.expectedTalentLengths = {
	PRIEST		= {28, 27, 27},
	DEATHKNIGHT	= {28, 29, 31},
	ROGUE		= {27, 28, 28},
	HUNTER		= {26, 27, 28},
	MAGE		= {30, 28, 28},
	PALADIN		= {26, 26, 26},
	WARRIOR		= {31, 27, 27},
	SHAMAN		= {25, 29, 26},
	WARLOCK		= {28, 27, 26},
	DRUID		= {28, 30, 27},
}

Utopia.buffs = {
	[L["Armor"]] = {
		icon = select(3, GetSpellInfo(465)),
		attribute = L["Armor"],
		interested = "tank",
		spells = {
			[465] = {									-- Devotion Aura
				class			= "PALADIN",
				exclusive		= "aura",
				rankLevels		= {1, 10, 20, 30, 40, 50, 60, 70, 74, 79},
				amount			= 1150,		-- TODO - lvl 5 -> 80 calc
				minLevel		= 5,
				--amounts = {55, 160, 275, 390, 505, 620, 735, 861, 1015, 1205},
				--rankIDs = {465, 10290, 643, 10291, 1032, 10292, 10293, 27149, 48941, 48942},
				--improvedPercentagePerTalentPoint = 50/3,
				--maxTalentPoints = 3,
				--improved = 20138,							-- Improved Devotion Aura
				--regex = true,
			},
			[8072] = {									-- Stoneskin (now non-stacking or?)
				class			= "SHAMAN",
				totem			= "earth",
				source			= 8071,						-- Stoneskin Totem
				amount			= 1150,		-- TODO - lvl 5 -> 80 calc
				minLevel		= 48,
				--rankLevels = {4, 14, 24, 34, 44, 54, 63, 70, 73, 78},
				--amounts = {95, 200, 310, 420, 530, 640, 750, 860, 980, 1150},
				--rankIDs = {8071, 8154, 8155, 10406, 10407, 10408, 25508, 25509, 58751, 58753},
				--improved = 16258,
				--maxTalentPoints = 2,
				--improvedPercentagePerTalentPoint = 10,
				--regex = true,
			},
		},
	},
--	[L["Armor Totem"]] = {
--		icon = select(3, GetSpellInfo(8071)),
--		attribute = L["Armor"],
--		interested = "tank",
--		spells = {
--			[8072] = {										-- Stoneskin
--				class = "SHAMAN",
--				totem = "earth",
--				source = 8071,								-- Stoneskin Totem
--				rankLevels = {4, 14, 24, 34, 44, 54, 63, 70, 73, 78},
--				amounts = {95, 200, 310, 420, 530, 640, 750, 860, 980, 1150},
--				rankIDs = {8071, 8154, 8155, 10406, 10407, 10408, 25508, 25509, 58751, 58753},
--				improved = 16258,
--				maxTalentPoints = 2,
--				improvedPercentagePerTalentPoint = 10,
--				regex = true,
--			},
--		},
--	},
--	[L["Attack Power"]] = {
--		icon = select(3, GetSpellInfo(47436)),
--		attribute = L["AP"],
--		interested = "melee,tank",
--		reportable = true,
--		spells = {
--			[6673] = {										-- Battle Shout
--				class = "WARRIOR",
--				exclusive = "warriorbuff",
--				amount = 155,		-- TODO - lvl 5 -> 80 calc
--				level 20,
--				rankLevels = {1, 12, 22, 32, 42, 52, 60, 69, 78},
--				amounts = {15, 35, 55, 85, 130, 185, 232, 305, 548},
--				rankIDs = {6673, 5242, 6192, 11549, 11550, 11551, 25289, 2048, 47436},
--				improvedPercentagePerTalentPoint = 5,
--				maxTalentPoints = 5,
--				improved = 12861,							-- Commanding Presence
--				regex = 1,
--			},
--			[48932] = {										-- Blessing of Might
--				alternate = 27141,							-- Greater Blessing of Might
--				alternateOffset = 5,						-- How many ranks to add if it's the alternate spell
--				class = "PALADIN",
--				exclusive = "blessing",
--				rankLevels = {4, 12, 22, 32, 42, 52, 60, 70, 73, 79},
--				amounts = {20, 35, 55, 85, 130, 185, 232, 306, 410, 550},
--				rankIDs = {19740, 19834, 19835, 19836, 19837, 19838, 25291, 27140, 48931, 48932},
--				rankIDsAlternate = {25782, 25916, 27141, 48933, 48934},
--				improvedPercentagePerTalentPoint = 25/2,
--				maxTalentPoints = 2,
--				improved = 20045,							-- Improved Blessing of Might
--				regex = 1,
--			},
--		},
--	},
	[L["Attack Power"]] = {			-- Was Attack Power (%)
		icon = select(3, GetSpellInfo(19506)),
		attribute = L["AP"],
		interested = "melee,tank",
		spells = {
			[19740] = {										-- Blessing of Might
				class			= "PALADIN",
				exclusive		= "blessing",
				amount			= 10,
				amountType		= "%",
				minLevel		= 56,
			},
			[19506] = {										-- Trueshot Aura
				class			= "HUNTER",
				spec			= "Marksmanship",
				amount			= 10,
				amountType		= "%",
				requiredTalent	= 19506,						-- Trueshot Aura
				minLevel		= 25,
			},
			[55972] = {										-- Abominable Might
				class			= "DEATHKNIGHT",
				spec			= "Blood",
				amount			= 10,
				amountType		= "%",
				requiredTalent	= 53138,					-- Abomination's Might (Note the difference in name)
				minLevel		= 55,
				temporary		= true,
			},
			[30802] = {										-- Unleashed Rage
				class			= "SHAMAN",
				spec			= "Enhancement",
				amountPerTalentPoint = 10/2,
				maxTalentPoints = 2,
				amountType		= "%",
				requiredTalent	= 30802,
				minLevel		= 30,
				temporary		= true,
			},
		},
	},
	["Bloodlust/Heroism"] = {
		icon = select(3, GetSpellInfo(Utopia.bloodlustID)),
		attribute = L["Haste"],
		spells = {
			[Utopia.bloodlustID] = {						-- Bloodlust / Heroism
				class			= "SHAMAN",
				amount			= 30,
				amountType		= "%",
				minLevel		= 70,
				temporary		= true,
			},
			[80353] = {										-- Time Warp
				class			= "MAGE",
				amount			= 30,
				amountType		= "%",
				minLevel		= 85,
				temporary		= true,
			},
			[90355] = {										-- Ancient Hysteria
				class			= "HUNTER",
				pet				= L["Core Hound"],
				spec			= "Beastmaster",
				amount			= 30,
				amountType		= "%",
				minLevel		= 57,						-- Min level based on lowest level Core Hounds (I think)..
			},
		},
	},
	[L["Crit Chance"]] = {
		icon = select(3, GetSpellInfo(17007)),
		attribute = L["Crit"],
		spells = {
			[17007] = {										-- Leader of the Pack
				class			= "DRUID",
				spec			= "Feral",
				amount			= 5,
				amountType		= "%",
				requiredTalent	= 17007,					-- Leader of the Pack
				minLevel		= 40,
				temporary		= true,
			},
			[29801] = {										-- Rampage
				class			= "WARRIOR",
				spec			= "Fury",
				amount			= 5,
				amountType		= "%",
				requiredTalent	= 29801,					-- Rampage
				minLevel		= 50,
				temporary		= true,
			},
			[51698] = {										-- Honor Among Thieves
				class			= "ROGUE",					-- TODO Check Debuff Name
				spec			= "Subtlety",
				amount			= 5,
				amountType		= "%",
				requiredTalent	= 51698,					-- Honor Among Thieves
				minLevel		= 25,
				temporary		= true,
			},
			[24604] = {										-- Furious Howl
				class			= "HUNTER",
				pet				= L["Wolf"],
				amount			= 5,
				amountType		= "%",
				temporary		= true,
			},
			[90309] = {										-- Terrifying Roar
				class			= "HUNTER",
				spec			= "Beastmaster",
				pet				= L["Devilsaur"],
				amount			= 5,
				amountType		= "%",
				temporary		= true,
				requiredTalent	= 53270,					-- Beast Mastery
				minLevel		= 40,
			},
			[51466] = {										-- Elemental Oath
				class			= "SHAMAN",
				spec			= "Elemental",
				amountPerTalentPoint = 2.5,
				maxTalentPoints	= 2,
				amountType		= "%",
				requiredTalent	= 51466,					-- Elemental Oath
				minLevel		= 25,
				temporary		= true,
			},
		},
	},
	--[L["Crit Chance (Spell)"]] = {
	--	icon = select(3, GetSpellInfo(24907)),
	--	attribute = L["Spell Crit"],
	--	interested = "caster,healer",
	--	spells = {
			--[24907] = {										-- Moonkin Aura
			--	class = "DRUID",
			--	spec = "Balance",
			--	amount = 5,
			--	amountType = "%",
			--	requiredTalent = 24858,						-- Moonkin Form
			--	minLevel = 40,
			--},
	--	},
	--},
	[L["Damage (%)"]] = {
		icon = select(3, GetSpellInfo(34460)),
		attribute = L["Damage Modifier"],
		attributeShort = L["Damage"],
		interested = "melee,caster",
		spells = {
			[34460] = {										-- Ferocious Inspiration
				class			= "HUNTER",
				spec			= "Beast Mastery",
				amount			= 3,
				amountType		= "%",
				temp			= true,
				requiredTalent	= 34460,					-- Ferocious Inspiration
				minLevel		= 30,
				temporary		= true,
			},
			[31876] = {										-- Communion (was Sanctified Retribution)
				class			= "PALADIN",				-- TODO: Is this the name of the raid buff? Not found one on wowhead.
				spec			= "Retribution",
				amount			= 3,
				amountType		= "%",
				requiredTalent	= 31876,					-- Communion (was Sanctified Retribution)
				minLevel		= 30,
			},
			[82930] = {										-- Arcane Tactics
				class			= "MAGE",
				spec			= "Arcane",
				amount			= 3,
				amountType		= "%",
				requiredTalent	= 82930,					-- Arcane Tactics
				minLevel		= 25,
			},
		},
	},
--	[L["Damage Reduction (%)"]] = {
--		icon = select(3, GetSpellInfo(20911)),
--		attribute = L["Damage Reduction"],
--		attributeShort = L["Reduction"],
--		interested = "tank",
--		spells = {
--			[20911] = {										-- Blessing of Sanctuary
--				alternate = 25899,							-- Greater Blessing of Sanctuary
--				class = "PALADIN",
--				spec = "Protection",
--				exclusive = "blessing",
--				amount = 3,
--				amountType = "%",
--				requiredTalent = 20911,						-- Blessing of Sanctuary
--				minLevel = 30,
--			},
--			[63944] = {										-- Renewed Hope
--				class = "PRIEST",
--				spec = "Discipline",
--				amount = 3,
--				amountType = "%",
--				requiredTalent = 63944,						-- Renewed Hope
--				minLevel = 45,
--				temporary = true,
--			},
--		}
--	},
	[L["Damage Reduction Physical (%)"]] = {
		icon = select(3, GetSpellInfo(16177)),
		attribute = L["Physical Damage Reduction"],
		attributeShort = L["Reduction"],
		interested = "tank",
		spells = {
			[16177] = {										-- Ancestral Fortitude
				class			= "SHAMAN",
				spec			= "Restoration",
				amountPerTalentPoint = 10/2,
				maxTalentPoints	= 2,
				amountType		= "%",
				requiredTalent	= 16176,						-- Ancestral Healing
				minLevel		= 20,
				temporary		= true,
			},
			[14893] = {										-- Inspiration
				class			= "PRIEST",
				spec			= "Holy",
				amountPerTalentPoint = 10/2,
				maxTalentPoints	= 2,
				amountType		= "%",
				requiredTalent	= 14892,						-- Inspiration
				minLevel		= 20,
				temporary		= true,
			},
		},
	},
--	[L["Haste"]] = {
--		icon = select(3, GetSpellInfo(53648)),
--		attribute = L["Haste"],
--		interested = "melee,caster,healer",
--		spells = {
--			[53648] = {										-- Swift Retribution
--				class = "PALADIN",
--				spec = "Retribution",
--				amountPerTalentPoint = 1,
--				maxTalentPoints = 3,
--				amountType = "%",
--				requiredTalent = 53648,						-- Swift Retribution
--				minLevel = 50,
--			},
--			[48396] = {										-- Improved Moonkin Form
--				class = "DRUID",
--				spec = "Moonkin",
--				amountPerTalentPoint = 1,
--				maxTalentPoints = 3,
--				amountType = "%",
--				requiredTalent = 48396,						-- Improved Moonkin Form
--				minLevel = 41,
--			},
--		},
--	},
	[L["Haste (Melee)"]] = {
		icon = select(3, GetSpellInfo(55610)),
		attribute = L["Haste"],
		interested = "melee",
		spells = {
			[55610] = {										-- Improved Icy Talons
				alternate		= 50887,					-- Icy Talons (The DK themself only get this aura)
				class			= "DEATHKNIGHT",
				spec			= "Frost",
				amount			= 10,
				amountType		= "%",
				requiredTalent	= 55610,					-- Improved Icy Talons
				minLevel		= 55,						-- 25?
				temporary		= true,
			},
			[8512] = {										-- Windfury	Totem
				class			= "SHAMAN",
				totem			= "air",
				amount			= 10,
				amountType		= "%",
				minLevel		= 32,
			},
			[53290] = {										-- Hunting Party
				class			= "HUNTER",
				spec			= "Survival",
				amount			= 10,
				amountType		= "%",
				requiredTalent	= 53290,					-- Hunting Party
				minLevel		= 30,
				temporary		= true,
			},
		},
	},
	[L["Haste (Spell)"]] = {
		icon = select(3, GetSpellInfo(3738)),
		attribute = L["Haste"],
		interested = "caster,healer",
		spells = {
			[3738] = {										-- Wrath of Air Totem
				class			= "SHAMAN",
				totem			= "air",
				amount			= 5,
				amountType		= "%",
				minLevel		= 44,
			},
			[24907] = {										-- Moonkin Aura
				alternate		= 24858,
				class			= "DRUID",
				spec			= "Moonkin",
				amount			= 5,
				amountType		= "%",
				requiredTalent	= 24858,					-- Moonkin Form
				minLevel		= 20,
			},
			[15473] = {										-- Shadowform
				--alternate		= 15473,					-- Shadowform
				class			= "PRIEST",					-- TODO : Check buff name if any
				spec			= "Shadow",
				amount			= 5,
				amountType		= "%",
				requiredTalent	= 15473,					-- Shadowform
				minLevel		= 20,
			},
		},
	},
--	[L["Healing Received"]] = {
--		icon = select(3, GetSpellInfo(33891)),
--		attribute = L["Healing"],
--		interested = "healer",
--		spells = {
--			[33891] = {										-- Tree of Life
--				class = "DRUID",
--				spec = "Restoration",
--				amount = 6,
--				amountType = "%",
--				requiredTalent = 33891,						-- Tree of Life
--				minLevel = 50,
--			},
--			[20140] = {										-- Improved Devotion Aura
--				class = "PALADIN",
--				spec = "Protection",
--				amountPerTalentPoint = 2,
--				maxTalentPoints = 3,
--				amountType = "%",
--				requiredTalent = 20140,						-- Improved Devotion Aura
--				minLevel = 25,
--			},
--		},
--	},
--	[L["Health"]] = {
--		icon = select(3, GetSpellInfo(47440)),
--		attribute = L["Health"],
--		interested = "tank,healer",
--		spells = {
--			[6307] = {										-- Blood Pact
--				class = "WARLOCK",
--				pet = L["Imp"],
--				amount = 165,
--				minLevel = 4,
--				rankLevels = {4, 14, 26, 38, 50, 62, 74},
--				amounts = {20, 70, 160, 270, 380, 660, 1330},
--				rankIDs = {6307, 7804, 7805, 11766, 11767, 27268, 47982},
--				improved = 18694,							-- Improved Imp
--				improvedPercentagePerTalentPoint = 10,
--				maxTalentPoints = 3,
--				regex = true,
--			},
--			[47440] = {										-- Commanding Shout
--				class = "WARRIOR",
--				exclusive = "warriorbuff",
--				rankLevels = {68, 74, 80},
--				amounts = {1080, 1855, 2255},
--				rankIDs = {469, 47439, 47440},
--				improvedPercentagePerTalentPoint = 5,
--				maxTalentPoints = 5,
--				improved = 12861,							-- Commanding Presence
--				regex = true,
--			},
--		},
--	},
	[L["Mana"]] = {
		icon = select(3, GetSpellInfo(1459)),
		attribute = L["Mana"],
		interested = "manauser",
		reportable = true,
		spells = {
			[1459] = {										-- Arcane Brilliance
				class			= "MAGE",
				amount			= 600,
				minLevel		= 58,
			},
			[61316] = {										-- Dalaran Brilliance
				class			= "MAGE",
				amount			= 600,
				minLevel		= 80,
			},
			[54424] = {										-- Fel Intelligence
				class			= "WARLOCK",
				pet				= L["Felhunter"],
				amount			= 600,
				minLevel		= 32,
			},
		},
	},
	[L["Mana Regen"]] = {
		icon = select(3, GetSpellInfo(5675)),
		attribute = L["mp5"],
		interested = "manauser",
		spells = {
			[19740] = {										-- Blessing of Might
				class			= "PALADIN",
				exclusive		= "blessing",
				amount			= 94,
			},
			[54424] = {										-- Fel Intelligence
				class			= "WARLOCK",
				pet				= L["Felhunter"],
				amount			= 94,
				minLevel		= 32,
			},
			[5675] = {										-- Mana Spring Totem
				class			= "SHAMAN",
				totem			= "water",
				amount			= 94,
				minLevel		= 42,
			},
		},
	},
	[GetSpellInfo(57669)] = {								-- Replenishment
		icon = select(3, GetSpellInfo(57669)),
		id = 57669,
		attribute = L["Mana Regen"],
		interested = "manauser",
		spells = {
			[31876] = {										-- Communion (was Judgements of the Wise)
				alternate = 57669,							-- Replenishment
				class = "PALADIN",
				spec = "Retribution",
				requiredTalent = 31876,						-- Communion (was Judgements of the Wise)
				minLevel = 40,
				temporary = true,
			},
			[34914] = {										-- Vampiric Touch
				alternate = 57669,							-- Replenishment
				class = "PRIEST",
				spec = "Shadow",
				requiredTalent = 34914,						-- Vampiric Touch
				minLevel = 30,
				temporary = true,
			},
			[44561] = {										-- Enduring Winter
				alternate = 57669,							-- Replenishment
				class = "MAGE",
				spec = "Frost",
				requiredTalent = 44561,						-- Enduring Winter
				minLevel = 25,
				temporary = true,
			},
			[30293] = {										-- Soul Leech
				alternate = 57669,							-- Replenishment
				class = "WARLOCK",
				spec = "Destruction",
				requiredTalent = 30293,						-- Soul Leech
				minLevel = 45,
				temporary = true,
			},
			[48539] = {										-- Revitalise
				alternate = 57669,							-- Replenishment
				class = "DRUID",
				spec = "Restoration",
				requiredTalent = 48539,						-- Revitalise
				minLevel = 45,
				temporary = true,
			},
		},
	},
	[L["Spell Power"]] = {
		icon = select(3, GetSpellInfo(8227)),
		attribute = L["Spell Power"],
		interested = "manauser",
		spells = {
			[1459] = {										-- Arcane Brilliance
				class			= "MAGE",
				amount			= 6,
				amountType		= "%",
				minLevel		= 58,
			},
			[47236] = {										-- Demonic Pact (Temp Buff)
				class			= "WARLOCK",
				pet				= "any",
				amount			= 10,
				amountType		= "%",
				requiredTalent	= 47236,					-- Demonic Pact
				minLevel		= 35,
				temporary		= true,
			},
			[8227] = {										-- Flametongue Totem
				class			= "SHAMAN",
				totem			= "fire",
				amount			= 6,
				amountType		= "%",
				--rankLevels = {28, 38, 48, 58, 67, 71, 75, 80},
				--amounts = {25, 37, 49, 62, 73, 106, 122, 144},
				--rankIDs = {8227, 8249, 10526, 16387, 25557, 58649, 58652, 58656},
				--improvedPercentagePerTalentPoint = 5,
				--maxTalentPoints = 3,
				--improved = 52456,							-- Enhancing Totems
				--regex = true,
			},
			[77746] = {										-- Totemic Wrath
				class			= "SHAMAN",
				totem			= "fire",					-- Any fire totem
				spec			= "Elemental",
				amount			= 10,
				amountType		= "%",
				requiredTalent	= 77746,					-- Totemic Wrath
				--rankLevels = {50, 60, 70, 80},
				--amounts = {100, 120, 140, 280},
				--rankIDs = {30706, 57720, 57721, 57722},
				--requiredTalent = 57722,						-- Totem of Wrath
			},
		},
	},
--	[L["Spirit"]] = {
--		icon = select(3, GetSpellInfo(48073)),
--		attribute = L["Spirit"],
--		interested = "healer",
--		reportable = true,
--		spells = {
--			[48073] = {										-- Divine Spirit
--				alternate = 32999,							-- Prayer of Spirit
--				alternateOffset = 3,						-- How many ranks to add if it's the alternate spell
--				class = "PRIEST",
--				rankLevels = {30, 40, 50, 60, 70, 80},
--				amounts = {17, 23, 33, 40, 50, 80},
--				rankIDs = {14752, 14818, 14819, 27841, 25312, 48073},
--				rankIDsAlternate = {27681, 32999, 48074},
--				regex = true,
--			},
--			[57567] = {										-- Fel Intelligence
--				class = "WARLOCK",
--				pet = "Felhunter",
--				rankLevels = {32, 42, 52, 62, 72},
--				amounts = {18, 26, 32, 40, 64},
--				rankIDs = {54424, 57564, 57565, 57566, 57567},
--				improvedPercentagePerTalentPoint = 5,
--				maxTalentPoints = 2,
--				improved = 54038,							-- Improved Felhunter
--				regex = true,
--			},
--		},
--	},
	[L["Stamina"]] = {
		icon = select(3, GetSpellInfo(21562)),
		attribute = L["Stamina"],
		interested = "tank,healer",
		raidbuff = true,
		reportable = true,
		spells = {
			[21562] = {										-- Power Word: Fortitude
				class			= "PRIEST",
				amount			= 165,
				minLevel		= 14,
				--alternate = 25392,							-- Prayer of Fortitude
				--alternateOffset = 4,						-- How many ranks to add if it's the alternate spell
				--rankLevels = {1, 12, 24, 36, 48, 60, 70, 80},
				--amounts = {3, 8, 20, 32, 43, 54, 79, 165},
				--rankIDs = {1243, 1244, 1245, 2791, 10937, 10938, 25389, 48161},
				--rankIDsAlternate = {21562, 21564, 25392, 48162},
				--improvedPercentagePerTalentPoint = 15,
				--maxTalentPoints = 2,
				--improved = 14767,							-- Improved Power Word: Fortitude
				--regex = true,
			},
			[72590] = {										-- Fortitude
				amount			= 165,
				runescroll		= 49632,					-- Runescroll of Fortitude
				minLevel		= 80,
			},
			[6307] = {										-- Blood Pact
				class			= "WARLOCK",
				pet				= L["Imp"],
				amount			= 165,
				minLevel		= 4,
			},
			[469] = {										-- Commanding Shout
				class			= "WARRIOR",
				exclusive		= "warriorbuff",
				amount			= 165,
				minLevel		= 68,
				--regex			= true,
			},
			[90364] = {
				class			= "HUNTER",
				pet				= L["Silithid"],
				amount			= 165,
				minLevel		= 4,
			},
		},
	},
	[L["Stat Add"]] = {
		icon = select(3, GetSpellInfo(1126)),
		attribute = L["Stats"],
		raidbuff = true,
		reportable = true,
		spells = {
			[1126] = {										-- Mark of the Wild
				class			= "DRUID",
				amount			= 5,
				amountType		= "%",
			},
			[79062] = {										-- Blessing of Kings
				class			= "PALADIN",
				amount			= 5,
				amountType		= "%",
			},
			[69378] = {										-- Blessing of Forgotten Kings
				amount = 4,
				amountType = "%",
				runescroll = 49633,							-- Drums of Forgotten Kings
				minLevel = 80,
			},
		},
	},
	[L["Strength & Agility"]] = {
		icon = select(3, GetSpellInfo(8075)),
		attribute = L["Str & Agi"],
		interested = "melee,tank",
		spells = {
			[8075] = {										-- Strength of Earth Totem
				class			= "SHAMAN",
				totem			= "earth",
				amount			= 155,
			},
			[57330] = {										-- Horn of Winter
				class			= "DEATHKNIGHT",
				amount			= 155,
			},
			[93435] = {										-- Roar of Courage
				class			= "HUNTER",
				pet				= L["Cat"],					-- TODO - And Spirit Beast
				amount			= 155,
			},
			[6673] = {										-- Battle Shout
				class			= "WARRIOR",
				exclusive		= "warriorbuff",
				amount			= 155,
			},
		},
	},
}

Utopia.debuffs = {
	[L["Armor (Major)"]] = {
		icon = select(3, GetSpellInfo(7386)),
		attribute = L["Armor"],
		interested = "melee,tank",
		spells = {
			[8647] = {										-- Expose Armor
				class			= "ROGUE",
				amount			= 12,
				amountType		= "%",
				minLevel		= 36,
			},
			[7386] = {										-- Sunder Armor
				class			= "WARRIOR",
				amountPerStack	= 4,
				amountType		= "%",
				maxStacks		= 3,
				minLevel		= 18,
			},
--			[55754] = {										-- Acid Spit
-- Changed to 4% dmg buff (like Savage Combat?)
--				class = "HUNTER",
--				spec = "Beast Mastery",
--				pet = L["Worm"],
--				amountPerStack = 6,
--				amountType = "%",
--				maxStacks = 2,
--				minLevel = 60,								-- Pets have this at level 1, but hunter needs to be able to use Exotic pets
--			},
		},
	},
	[L["Armor (Minor)"]] = {
		icon = select(3, GetSpellInfo(770)),
		attribute = L["Armor"],
		interested = "melee,tank",
		reportable = true,
		spells = {
			--[50511] = {										-- Curse of Weakness
			--	class = "WARLOCK",
			--	amount = 4,
			--	amountType = "%",
			--	exclusive = "curse",
			--	minLevel = 4,
			--	priority = 2,
			--},
			[770] = {										-- Faerie Fire
				class			= "DRUID",
				amount			= 4,
				amountType		= "%",
				minLevel		= 18,
				priority		= 1,
				minLevel		= 24,
			},
			[16857] = {										-- Faerie Fire (Feral)
				class			= "DRUID",
				amount			= 4,
				amountType		= "%",
				minLevel		= 24,
				priority		= 1,
			},
			--[56631] = {										-- Sting
			--	class = "HUNTER",
			--	amount = 4,
			--	amountType = "%",
			--	pet = L["Wasp"],
			--	temporary = true,
			--	priority = 1,
			--},
		},
	},
	[L["Bleed Damage"]] = {
		icon = select(3, GetSpellInfo(33878)),
		interested = "melee,tank",
		spells = {
			[33878] = {										-- Mangle
				class			= "DRUID",
				amount			= 30,
				amountType		= "%",
				spec			= "Feral",
				requiredTalent	= 33917,					-- Mangle
				minLevel		= 10,
			},
			[16511] = {										-- Hemorrhage
				class			= "ROGUE",
				spec			= "Subtlety",
				amount			= 30,
				amountType		= "%",
				requiredTalent	= 16511,					-- Hemorrhage
				minLevel		= 20,
			},
			[29836] = {										-- Blood Frenzy
				class			= "WARRIOR",
				spec			= "Arms",
				amountPerTalentPoint = 15,
				amountType		= "%",
				maxTalentPoints	= 2,
				requiredTalent	= 29836,					-- Blood Frenzy
				minLevel		= 25,
			},
			[57386] = {										-- Stampede
				class			= "HUNTER",
				spec			= "Beast Mastery",
				pet				= L["Rhino"],
				amount			= 30,
				amountType		= "%",
			},
		},
	},
	[L["Damage Done (Physical)"]] = {
		icon = select(3, GetSpellInfo(1160)),
		attribute = L["Attack Power"],
		interested = "tank",
		spells = {
			[702] = {										-- Curse of Weakness
				class			= "WARLOCK",
				amount			= 10,
				amountType		= "%",
				exclusive		= "curse",
			},
			[99] = {										-- Demoralizing Roar
				class			= "DRUID",
				spec			= "Feral",
				amount			= 10,
				amountType		= "%",
				minLevel		= 15,
			},
			[1160] = {										-- Demoralizing Shout
				class			= "WARRIOR",
				amount			= 10,
				amountType		= "%",
				minLevel		= 52,
			},
			[26016] = {										-- Vindication
				class			= "PALADIN",
				spec			= "Protection",
				amount			= 10,
				amountType		= "%",
				requiredTalent	= 26016,
				minLevel		= 30,
			},
			[81131] = {										-- Scarlet Fever
				class			= "DEATHKNIGHT",
				spec			= "Blood",
				amount			= 10,
				amountType		= "%",
				requiredTalent	= 81131,
				minLevel		= 30,
			},
			--[55487] = {										-- Demoralizing Screech
			--	class = "HUNTER",
			--	rankLevels = {1, 16, 32, 48, 64, 80},
			--	amounts = {25, 45, 70, 100, 210, 410},
			--	ranksIDs = {24423, 24577, 24578, 24579, 27051, 55487},
			--	pet = L["Bird of Prey"],
			--	regex = true,
			--},
		},
	},
	[L["Cast Speed Slow"]] = {
		icon = select(3, GetSpellInfo(5761)),
		interested = "tank",
		exclude = function(unit) return UnitPowerMax(unit, 0) == 0 end,
		spells = {
			[1714] = {										-- Curse of Tongues
				class			= "WARLOCK",
				amount			= 30,
				amountType		= "%",
				exclusive		= "curse",
				minLevel		= 26,
			},
			[25810] = {										-- Mind-numbing Poison
				class			= "ROGUE",
				amount			= 30,
				amountType		= "%",
				minLevel		= 24,
			},
			[58604] = {										-- Lava Breath
				class			= "HUNTER",
				spec			= "Beast Mastery",
				pet				= L["Core Hound"],
				amount			= 25,
				amountType		= "%",
				requiredTalent	= 53270,					-- Beast Mastery
				temporary		= true,
			},
			[31589] = {										-- Slow
				class			= "MAGE",
				spec			= "Arcane",
				amount			= 30,
				amountType		= "%",
				requiredTalent	= 31589,					-- Slow
				minLevel		= 30,
      		},
		},
	},
--	[L["Critical Strike Chance Taken"]] = {
--		icon = select(3, GetSpellInfo(58410)),
--		interested = "melee,tank,caster",
--		spells = {
--			[54499] = {										-- Heart of the Crusader (buff name)
--				class = "PALADIN",
--				spec = "Retribution",
--				maxTalentPoints = 3,
--				amountPerTalentPoint = 1,
--				amountType = "%",
--				requiredTalent = 20337,						-- Heart of the Crusader (talent name)
--				minLevel = 15,
--			},
--			[58410] = {										-- Master Poisoner
--				class = "ROGUE",
--				spec = "Assassination",
--				maxTalentPoints = 3,
--				amountPerTalentPoint = 1,
--				amountType = "%",
--				requiredTalent = 58410,						-- Master Poisoner
--				minLevel = 50,
--			},
--			[30706] = {										-- Totem of Wrath
--				class = "SHAMAN",
--				totem = "fire",
--				spec = "Elemental",
--				amount = 3,
--				amountType = "%",
--				requiredTalent = 30706,						-- Totem of Wrath
--				rankLevels = {50, 60, 70, 80},
--				rankIDs = {30706, 57720, 57721, 57722},
--				minLevel = 50,
--			},
--		},
--	},
	[L["Healing Taken"]] = {
		icon = select(3, GetSpellInfo(12294)),
		interested = "tank",
		spells = {
			[12294] = {										-- Mortal Strike
				class = "WARRIOR",
				spec = "Arms",
				amount = 25,
				amountType = "%",
				requiredTalent = 12294,						-- Mortal Strike
				minLevel = 10,
			},
			[13218] = {										-- Wound Poison
				class = "ROGUE",
				amount = 25,
				amountType = "%",
				minLevel = 32,
			},
			[48301] = {										-- Mind Trauma
				class = "PRIEST",
				spec = "Shadow",
				amount = 25,
				amountType = "%",
				requiredTalent = 15273,						-- Improved Mind Blast
				minLevel = 15,
			},
			[7321] = {										-- Chilled
				class = "MAGE",								-- Need to validate that chilled was from this mage
				spec = "Frost",
				amountPerTalentPoint = 25 / 3,
				maxTalentPoints = 3,
				amountType = "%",
				requiredTalent = 11175,						-- Permafrost
				minLevel = 15,
			},
			[46910] = {										-- Furious Attacks
				class = "WARRIOR",
				spec = "Fury",
				amount = 25,
				amountType = "%",
				requiredTalent = 46910,						-- Furious Attacks
				minLevel = 45,
			},
			--[49050] = {										-- Aimed Shot
			--	class = "HUNTER",
			--	spec = "Marksmanship",
			--	amount = 50,
			--	amountType = "%",
			--	requiredTalent = 49050,						-- Aimed Shot
			--	minLevel = 20,
			--},
		},
	},
	--[L["Health Restore"]] = {
	--	icon = select(3, GetSpellInfo(20271)),
	--	interested = "tank,healer",
	--	reportable = true,
	--	spells = {
	--		[20271] = {										-- Judgement of Light
	--			class = "PALADIN",
	--			exclusive = "judge",
	--			minLevel = 4,
	--		},
	--	},
	--},
	--[L["Mana Restore"]] = {
	--	icon = select(3, GetSpellInfo(53408)),
	--	interested = "manauser",
	--	reportable = true,
	--	spells = {
	--		[53408] = {										-- Judgement of Wisdom
	--			class = "PALADIN",
	--			exclusive = "judge",
	--			minLevel = 12,
	--		},
	--	},		
	--},
	[L["Melee Attack Speed Slow"]] = {
		icon = select(3, GetSpellInfo(6343)),
		interested = "tank",
		spells = {
			[59921] = {										-- Frost Fever
				class = "DEATHKNIGHT",
				amount = 20,
				amountType = "%",
				minLevel = 55,
			},
			[48483] = {										-- Infected Wounds
				class = "DRUID",
				spec = "Feral",
				amountPerTalentPoint = 10,
				amountType = "%",
				maxTalentPoints = 2,
				requiredTalent = 48483,						-- Infected Wounds
				minLevel = 15,
			},
			[53695] = {										-- Judgements of the Just
				class = "PALADIN",
				spec = "Protection",
				amountPerTalentPoint = 10,
				amountType = "%",
				maxTalentPoints = 2,
				requiredTalent = 53695,						-- Judgements of the Just
				minLevel = 15,
			},
			[6343] = {										-- Thunder Clap
				class = "WARRIOR",
				amount = 20,
				amountType = "%",
				minLevel = 9,
			},
			[51692] = {										-- Waylay
				class = "ROGUE",
				amount = 20,
				amountType = "%",
				requiredTalent = 51692,
				minLevel = 15,
			},
			[8042] = {										-- Earth Shock
				class = "SHAMAN",
				amount = 20,
				amountType = "%",
				minLevel = 5,
			},
		},
	},
--	[L["Melee Hit Chance Reduction"]] = {
--		icon = select(3, GetSpellInfo(48468)),
--		interested = "tank",
--		spells = {
--			[48468] = {										-- Insect Swarm
--				class = "DRUID",
--				excludingGlyph = 54830,						-- Glyph of Insect Swarm (removes the hit effect)
--				amount = 3,
--				amountType = "%",
--				requiredTalent = 48468,						-- Insect Swarm
--				minLevel = 30,
--			},
--			[3043] = {										-- Scorpid Sting
--				class = "HUNTER",
--				amount = 3,
--				amountType = "%",
--				minLevel = 22,
--			},
--		},
--	},
	[L["Physical Vulnerability"]] = {
		icon = select(3, GetSpellInfo(58413)),
		interested = "tank,melee",
		spells = {
			[51682] = {										-- Savage Combat
				class			= "ROGUE",
				spec			= "Combat",
				amountPerTalentPoint = 2,
				amountType		= "%",
				maxTalentPoints	= 2,
				requiredTalent	= 51682,					-- Savage Combat
				minLevel		= 30,
			},
			[81327] = {										-- Brittle Bones
				class			= "DEATHKNIGHT",
				spec			= "Frost",
				amountPerTalentPoint = 2,
				amountType		= "%",
				maxTalentPoints	= 2,
				requiredTalent	= 81327,					-- Brittle Bones
				minLevel		= 20,
			},
		},
	},
	[L["Spell Critical Strike Chance"]] = {
		icon = select(3, GetSpellInfo(11095)),
		interested = "caster",
		spells = {
			[11095] = {										-- Critical Mass
				class			= "MAGE",					-- TODO Check Debuff Name
				spec			= "Fire",
				amount			= 5,
				amountType		= "%",
				requiredTalent	= 11095,					-- Critical Mass
				minLevel		= 25,
			},
			[17793] = {										-- Shadow and Flame
				class			= "WARLOCK",				-- TODO Check Debuff Name
				spec			= "Destruction",
				amount			= 5,
				amountType		= "%",
				requiredTalent	= 17793,					-- Shadow and Flame
				minLevel		= 10,
			},
			--[28593] = {										-- Winter's Chill
			--	class = "MAGE",
			--	spec = "Frost",
			--	amountPerStack = 1,
			--	maxStacks = 5,
			--	amountType = "%",
			--	maxTalentPoints = 3,
			--	requiredTalent = 28593,						-- Winter's Chill
			--	minLevel = 35,
			--	regex = true,
			--},
			--[17800] = {										-- Shadow Mastery
			--	class = "WARLOCK",
			--	spec = "Destruction",
			--	amount= 5,
			--	amountType = "%",
			--	maxTalentPoints = 5,
			--	requiredTalent = 17803,						-- Improved Shadow Bolt
			--	minLevel = 35,
			--	regex = true,
			--},
		},
	},
	[L["Spell Damage Taken"]] = {
		icon = select(3, GetSpellInfo(65142)),
		interested = "caster",
		spells = {
			[58410] = {										-- Master Poisoner
				class			= "ROGUE",
				spec			= "Assassination",
				amount			= 8,
				amountType		= "%",
				requiredTalent	= 58410,					-- Master Poisoner
				minLevel		= 30,
			},
			[1490] = {										-- Curse of the Elements
				class			= "WARLOCK",
				spec			= "Affliction",
				amount			= 8,
				amountType		= "%",
				exclusive		= "curse",
				minLevel		= 52,
			},
			[48506] = {										-- Earth and Moon
				class			= "DRUID",
				spec			= "Balance",
				amount			= 8,
				amountType		= "%",
				requiredTalent	= 48506,					-- Earth and Moon
				minLevel		= 30,
			},
			[65142] = {										-- Ebon Plague
				class			= "DEATHKNIGHT",
				spec			= "Unholy",
				amount			= 8,
				amountType		= "%",
				requiredTalent	= 51099,					-- Ebon Plaguebringer
				minLevel		= 55,
			},
		},
	},
--	[L["Spell Hit Chance Taken"]] = {
--		icon = select(3, GetSpellInfo(33193)),
--		interested = "caster",
--		spells = {
--			[33602] = {										-- Improved Faerie Fire
--				class = "DRUID",
--				spec = "Balance",
--				amountPerTalentPoint = 1,
--				amountType = "%",
--				maxTalentPoints = 3,
--				requiredTalent = 33602,						-- Improved Faerie Fire
--				minLevel = 40,
--			},
--			[33193] = {										-- Misery
--				class = "PRIEST",
--				spec = "Shadow",
--				amount = 3,
--				amountType = "%",
--				requiredTalent = 33193,						-- Misery
--				minLevel = 45,
--			},
--		},
--	},
}

-- Buffs we want to enhance the tooltips for, but are not showing them in the icon grid
Utopia.otherBuffs = {
	[7294] = {exclusive = "aura"},				-- Retribution Aura
	[19746] = {exclusive = "aura"},				-- Concentration Aura
	--[32223] = {exclusive = "aura"},				-- Crusader Aura (leave this one out, on purpose)
}

-- Mapping spells. These don't actually appear on the target, but are
-- 'hidden' auras that we have to infer, often given as an additional
-- effect to a spell.  (With the exception of Wound Poison which is a
-- straight mapping to cope with the varying names)

do
	Utopia.mapping = {}
--[[
	local paladinAuraList = {
		[GetSpellInfo(465)] = true,			-- Devotion Aura
		[GetSpellInfo(7294)] = true,		-- Retribution Aura
		[GetSpellInfo(19746)] = true,		-- Concentration Aura
		[GetSpellInfo(32223)] = true,		-- Crusader Aura
	}
	Utopia.mapping = {
		[GetSpellInfo(13218)] = {					-- Wound Poison (unranked name)
			class = "ROGUE",
			type = "map",
			list = {
				[GetSpellInfo(13225)] = true,		-- Wound Poison II
				[GetSpellInfo(13226)] = true,		-- Wound Poison III
				[GetSpellInfo(13227)] = true,		-- Wound Poison IV
				[GetSpellInfo(27188)] = true,		-- Wound Poison V
				[GetSpellInfo(57977)] = true,		-- Wound Poison VI
				[GetSpellInfo(57978)] = true,		-- Wound Poison VII
			},
		},

		[GetSpellInfo(2818)] = {					-- Deadly Poison (unranked name)
			class = "ROGUE",						-- Mapping for Master Poisoner to work
			type = "map",
			list = {
				[GetSpellInfo(2819)] = true,		-- Deadly Poison II
				[GetSpellInfo(11353)] = true,		-- Deadly Poison III
				[GetSpellInfo(11354)] = true,		-- Deadly Poison IV
				[GetSpellInfo(25349)] = true,		-- Deadly Poison V
				[GetSpellInfo(26968)] = true,		-- Deadly Poison VI
				[GetSpellInfo(27187)] = true,		-- Deadly Poison VII
				[GetSpellInfo(57969)] = true,		-- Deadly Poison VIII
				[GetSpellInfo(57970)] = true,		-- Deadly Poison IX
			},
		},

		[GetSpellInfo(58410)] = {					-- Master Poisoner
			class = "ROGUE",
			requiredTalent = GetSpellInfo(58410),	-- Master Poisoner
			type = "trigger",
			list = {
				[GetSpellInfo(3408)] = true,		-- Crippling Poison
				[GetSpellInfo(41190)] = true,		-- Mind-numbing Poison
				[GetSpellInfo(13218)] = true,		-- Wound Poison
				[GetSpellInfo(2818)] = true,		-- Deadly Poison
			},
		},

		[GetSpellInfo(53696)] = {					-- Judgements of the Just
			class = "PALADIN",
			requiredTalent = GetSpellInfo(53696),	-- Judgements of the Just
			type = "trigger",
			list = {
				[GetSpellInfo(53408)] = true,		-- Judgement of Wisdom
				[GetSpellInfo(20271)] = true,		-- Judgement of Light
				[GetSpellInfo(53407)] = true,		-- Judgement of Justice
			},
		},

		[GetSpellInfo(20140)] = {					-- Improved Devotion Aura
			class = "PALADIN",
			requiredTalent = GetSpellInfo(20140),	-- Improved Devotion Aura
			type = "trigger",
			list = paladinAuraList,
		},

		[GetSpellInfo(53648)] = {					-- Swift Retribution
			class = "PALADIN",
			requiredTalent = GetSpellInfo(53648),	-- Swift Retribution
			type = "trigger",
			list = paladinAuraList,
		},

		[GetSpellInfo(31869)] = {					-- Sanctified Retribution
			class = "PALADIN",
			requiredTalent = GetSpellInfo(31869),	-- Sanctified Retribution
			type = "trigger",
			list = paladinAuraList,
		},

		[GetSpellInfo(33602)] = {					-- Improved Faerie Fire
			class = "DRUID",
			requiredTalent = GetSpellInfo(33602),	-- Improved Faerie Fire
			type = "trigger",
			list = {
				[GetSpellInfo(770)] = true,			-- Faerie Fire
				[GetSpellInfo(16857)] = true,		-- Faerie Fire (Feral)
			},
		},

		[GetSpellInfo(48396)] = {					-- Improved Moonkin Form
			class = "DRUID",
			requiredTalent = GetSpellInfo(48396),	-- Moonkin Aura
			list = {
				[GetSpellInfo(24907)] = true,		-- Moonkin Aura
			}
		},

		[GetSpellInfo(33917)] = {
			class = "DRUID",
			requiredTalent = GetSpellInfo(33917),
			type = "trigger",
			list = {
				[GetSpellInfo(48564)] = true,		-- Mangle - Bear
				[GetSpellInfo(48566)] = true,		-- Mangle - Cat
			},
		},
	}
]]
end

--[===[@debug@
for Type,data in pairs(Utopia.debuffs) do
	assert(type(Type) == "string")
	assert(data.spells)
	for spellID,info in pairs(data.spells) do
		assert(info.class)
		assert(type(spellID) == "number")
		if (info.amount) then
			assert(type(info.amount) == "number")
		elseif (info.amountsPerStack) then
			assert(info.rankLevels)
			assert(#info.amountsPerStack == #info.rankLevels)
		elseif (info.amounts) then
			assert(type(info.amounts) == "table")
			assert(info.rankLevels)
			assert(#info.amounts == #info.rankLevels)
		end
		if (info.rankIDs) then
			if (info.amounts) then
				assert(#info.rankIDs == #info.amounts)
			end
			if (info.rankLevels) then
				assert(#info.rankIDs == #info.rankLevels)
			end
			local spellName = GetSpellInfo(spellID)
			local n = GetSpellInfo(info.rankIDs[1])
			for i,id in ipairs(info.rankIDs) do
				if (GetSpellInfo(id) ~= spellName) then
					error(format("Utopia: [%q].rankIDs[%d] (%d) ~= %q", spellName, i, id, n))
				end
			end
			if (info.rankIDsAlternate) then
				assert(type(info.alternateOffset) == "number")
				assert(#info.rankIDsAlternate == #info.rankIDs + info.alternateOffset)
				n = GetSpellInfo(info.rankIDsAlternate[1])
				for i,id in ipairs(info.rankIDs) do
					if (GetSpellInfo(id) ~= n) then
						error(format("[%q].rankIDsAlternate[%d] (%d) ~= %q", spellName, i, id, n))
					end
				end
			end
		end
	end
end

if (Utopia.mapping) then
	for name,data in pairs(Utopia.mapping) do
		assert(data.class)
		assert(data.list)
		for spellName,True in pairs(data.list) do
			assert(type(spellName) == "string")
			assert(True)
		end
	end
end

-- ValidateAgainstClassData
-- Checks maxTalentPoints values read from actual live talents by LGT against maxTalentPoints we have specified in our data

local LGT = LibStub("LibGroupTalents-1.0")

local function validateSub(mode, class)
	for cat,info in pairs(Utopia[mode]) do
		for id,spellInfo in pairs(info.spells) do
			if (spellInfo.class == class and LGT.classTalentData[spellInfo.class]) then
				if (spellInfo.maxTalentPoints) then
					local maxRank = LGT:GetClassTalentInfo(spellInfo.class, spellInfo.requiredTalent or spellInfo.improved)
					if (maxRank) then
						if (maxRank ~= spellInfo.maxTalentPoints) then
							error(format("Utopia.%s[%q].spells[%q].maxTalentPoints = %d. Live data = %d", mode, cat, GetSpellInfo(spellInfo.requiredTalent or spellInfo.improved) or "nil", spellInfo.maxTalentPoints, maxRank))
						end
					else
						error(format("Did not find talent called %s in %s data", GetSpellInfo(spellInfo.requiredTalent or spellInfo.improved) or "nil", spellInfo.class))
					end
				end
			end
		end
	end
end

function Utopia:ValidateAgainstClassData(class)
	validateSub("buffs", class)
	validateSub("debuffs", class)
end
--@end-debug@]===]
